unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Param, Compress, ShellAPI, ComCtrls, Menus, Clipbrd,
  FileCtrl, Registry, ShlObj;

const
  NoneMode = 0; // 񏑌Ƀ[h
  ArcMode  = 1; // ɍ쐬[h
  ResMode  = 2; // ɕ[h
  ViewMode = 3; // ɉ{[h

type
  TDirFile = record
    dc: Integer;
    fc: Integer;
  end;

  TFrameForm = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter2: TSplitter;
    Panel4: TPanel;
    Memo1: TMemo;
    Parameter1: TParameter;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label3: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    CheckBox7: TCheckBox;
    Label4: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Edit3: TEdit;
    Label5: TLabel;
    UpDown3: TUpDown;
    PopupMenu1: TPopupMenu;
    F1: TMenuItem;
    H1: TMenuItem;
    FontDialog1: TFontDialog;
    N1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    N2: TMenuItem;
    A1: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    Label6: TLabel;
    Edit4: TEdit;
    UpDown4: TUpDown;
    N4: TMenuItem;
    N5: TMenuItem;
    X1: TMenuItem;
    N6: TMenuItem;
    A2: TMenuItem;
    Edit5: TEdit;
    Label7: TLabel;
    UpDown5: TUpDown;
    Label8: TLabel;
    ComboBox3: TComboBox;
    N9: TMenuItem;
    RealData1: TMenuItem;
    FullSpecData1: TMenuItem;
    RealData2: TMenuItem;
    RealData3: TMenuItem;
    D1: TMenuItem;
    FullSpec1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox2Enter(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure H1Click(Sender: TObject);
    procedure F1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure A2Click(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox3Enter(Sender: TObject);
    procedure RealData1Click(Sender: TObject);
    procedure FullSpecData1Click(Sender: TObject);
    procedure RealData2Click(Sender: TObject);
    procedure RealData3Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure FullSpec1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure AcceptFiles(var Msg: TMessage); message WM_DROPFILES;
    procedure WMCopyData(var Msg: TWMCopyData); message WM_COPYDATA;
  public
    { Public 錾 }
    ShowOption: Integer; // tH[\邩ǂ߂l
    Mode: Integer;
    Arrow: String;
    ArcFixedDir: String;
    ResFixedDir: String;
    TempDir: String;
    OldCombo1: Integer;
    OldCombo2: Integer;
    Archiver: TArchiver;
    Recs: TSearchRecs;
    procedure InitAll;
    procedure InitParameter;
    procedure SaveParameter;
    procedure DoExecute;
    function DispData: TDirFile;
    function Percent(X, Y: Int64): String;
    function ArchiveFile(FileName: String): Boolean;
    function ArcCount: Integer;
    function DirCount: Integer;
    function AllCount: Integer;
    function GetRecs: Integer;
    function Rec2Str(Rec: TSearchRec): String;
    function FileHeader2Str(FH: TFileHeader): String;
    function DeleteFiles(Path: String): Integer;
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.InitAll;
begin
  WindowState := wsNormal;
  Left := 200;
  Top := 115;
  ClientWidth := 439;
  ClientHeight := 374;
  Panel1.Height := 166;
  Panel3.Width := 218;
  ComboBox1.ItemIndex := 0;
  ResFixedDir := '';
  ComboBox2.ItemIndex := 0;
  ArcFixedDir := '';
  ComboBox3.ItemIndex := 3;
  CheckBox1.Checked := True;
  CheckBox2.Checked := False;
  CheckBox3.Checked := False;
  CheckBox4.Checked := True;
  CheckBox5.Checked := False;
  CheckBox6.Checked := False;
  CheckBox7.Checked := True;
  UpDown1.Position := 64;
  UpDown2.Position := 95;
  UpDown3.Position := 1;
  UpDown4.Position := 256;
  UpDown5.Position := 1;
  if A1.Checked then
  begin
    try
      AssociateDelete('.cps'); // gq̊֘At̉
    except
      ;
    end;
  end;
  X1.Checked := False;
  N6.Checked := False;
  D1.Checked := False;
  Memo1.WordWrap := False;
  Memo1.ScrollBars := ssBoth;
  Memo1.Font.Name := 'lr oSVbN';
  Memo1.Font.Size := 9;
  Memo1.Font.Style := [];
  Memo1.Font.Color := -2147483640;
  Caption := 'Compressor Version 1.1';
end;

procedure TFrameForm.InitParameter;
begin
  { Parameter1 Ăep[^t@C烍[hB}
  Parameter1.Init;
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    if WindowState <> wsMaximized then
    begin
      Left := Parameter1['Left']; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
      Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
      ClientWidth := Parameter1['ClientWidth']; // Integer ^̃f[^𓾂B
      ClientHeight := Parameter1['ClientHeight']; // Integer ^̃f[^𓾂B
    end;
    Panel1.Height := Parameter1['Panel1.Height']; // Integer ^̃f[^𓾂B
    Panel3.Width := Parameter1['Panel3.Width']; // Integer ^̃f[^𓾂B
    ComboBox1.ItemIndex := Parameter1['ComboBox1.ItemIndex']; // Integer ^̃f[^𓾂B
    ResFixedDir := Parameter1.VStrings['ResFixedDir']; // String ^̃f[^𓾂B
    ComboBox2.ItemIndex := Parameter1['ComboBox2.ItemIndex']; // Integer ^̃f[^𓾂B
    ArcFixedDir := Parameter1.VStrings['ArcFixedDir']; // String ^̃f[^𓾂B
    ComboBox3.ItemIndex := Parameter1['ComboBox3.ItemIndex']; // Integer ^̃f[^𓾂B
    CheckBox1.Checked := Parameter1.VBools['CheckBox1.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox2.Checked := Parameter1.VBools['CheckBox2.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox3.Checked := Parameter1.VBools['CheckBox3.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox4.Checked := Parameter1.VBools['CheckBox4.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox5.Checked := Parameter1.VBools['CheckBox5.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox6.Checked := Parameter1.VBools['CheckBox6.Checked']; // Boolean ^̃f[^𓾂B
    CheckBox7.Checked := Parameter1.VBools['CheckBox7.Checked']; // Boolean ^̃f[^𓾂B
    UpDown1.Position := Parameter1['UpDown1.Position']; // Integer ^̃f[^𓾂B
    UpDown2.Position := Parameter1['UpDown2.Position']; // Integer ^̃f[^𓾂B
    UpDown3.Position := Parameter1['UpDown3.Position']; // Integer ^̃f[^𓾂B
    UpDown4.Position := Parameter1['UpDown4.Position']; // Integer ^̃f[^𓾂B
    UpDown5.Position := Parameter1['UpDown5.Position']; // Integer ^̃f[^𓾂B
    X1.Checked := Parameter1.VBools['X1.Checked']; // Boolean ^̃f[^𓾂B
    N6.Checked := Parameter1.VBools['N6.Checked']; // Boolean ^̃f[^𓾂B
    D1.Checked := Parameter1.VBools['D1.Checked']; // Boolean ^̃f[^𓾂B
    Memo1.WordWrap := Parameter1.VBools['Memo1.WordWrap']; // Boolean ^̃f[^𓾂B
    Memo1.Font.Name := Parameter1.VStrings['Memo1.Font.Name']; // String ^̃f[^𓾂B
    Memo1.Font.Size := Parameter1['Memo1.Font.Size']; // Integer ^̃f[^𓾂B
    Memo1.Font.Style := Parameter1.VFontStyles['Memo1.Font.Style']; // TFontStyle ^̃f[^𓾂B
    Memo1.Font.Color := Parameter1['Memo1.Font.Color']; // Integer ^̃f[^𓾂B
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('Compressor ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['WindowState'] := Integer(WindowState); // Integer ^̃f[^𓾂B
    Parameter1['Left'] := Left; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Parameter1['Top'] := Top; // Integer ^̃f[^𓾂B
    ClientWidth := 439; Parameter1['ClientWidth'] := ClientWidth; // Integer ^̃f[^𓾂B
    ClientHeight := 374; Parameter1['ClientHeight'] := ClientHeight; // Integer ^̃f[^𓾂B
    Parameter1['Panel1.Height'] := Panel1.Height; // Integer ^̃f[^𓾂B
    Parameter1['Panel3.Width'] := Panel3.Width; // Integer ^̃f[^𓾂B
    ComboBox1.ItemIndex := 0;
    Parameter1['ComboBox1.ItemIndex'] := ComboBox1.ItemIndex; // Integer ^̃f[^𓾂B
    ResFixedDir := '';
    Parameter1.VStrings['ResFixedDir'] := ResFixedDir; // String ^̃f[^𓾂B
    ComboBox2.ItemIndex := 0;
    Parameter1['ComboBox2.ItemIndex'] := ComboBox2.ItemIndex; // Integer ^̃f[^𓾂B
    ArcFixedDir := '';
    Parameter1.VStrings['ArcFixedDir'] := ArcFixedDir; // String ^̃f[^𓾂B
    ComboBox3.ItemIndex := 3;
    Parameter1['ComboBox3.ItemIndex'] := ComboBox3.ItemIndex; // Integer ^̃f[^𓾂B
    Parameter1.VBools['CheckBox1.Checked'] := CheckBox1.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['CheckBox2.Checked'] := CheckBox2.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['CheckBox3.Checked'] := CheckBox3.Checked; // Integer ^̃f[^𓾂B
    Parameter1.VBools['CheckBox4.Checked'] := CheckBox4.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['CheckBox5.Checked'] := CheckBox5.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['CheckBox6.Checked'] := CheckBox6.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['CheckBox7.Checked'] := CheckBox7.Checked; // Boolean ^̃f[^𓾂B
    Parameter1['UpDown1.Position'] := UpDown1.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown2.Position'] := UpDown2.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown3.Position'] := UpDown3.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown4.Position'] := UpDown4.Position; // Integer ^̃f[^𓾂B
    Parameter1['UpDown5.Position'] := UpDown5.Position; // Integer ^̃f[^𓾂B
    Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['N6.Checked'] := N6.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['D1.Checked'] := D1.Checked; // Boolean ^̃f[^𓾂B
    Parameter1.VBools['Memo1.WordWrap'] := Memo1.WordWrap; // Boolean ^̃f[^𓾂B
    Parameter1.VStrings['Memo1.Font.Name'] := Memo1.Font.Name; // String ^̃f[^𓾂B
    Parameter1['Memo1.Font.Size'] := Memo1.Font.Size; // Integer ^̃f[^𓾂B
    Parameter1.VFontStyles['Memo1.Font.Style'] := Memo1.Font.Style; // TFontStyle ^̃f[^𓾂B
    Parameter1['Memo1.Font.Color'] := Memo1.Font.Color; // Integer ^̃f[^𓾂B
  end;

  if Memo1.WordWrap then
    Memo1.ScrollBars := ssNone
  else
    Memo1.ScrollBars := ssBoth;

  OldCombo1 := ComboBox1.ItemIndex;
  OldCombo2 := ComboBox2.ItemIndex;

  Archiver.PackOption := CheckBox1.Checked;
  Archiver.ResWriteOption := CheckBox2.Checked;
  Archiver.CompressOption := CheckBox4.Checked;
  Archiver.ArcWriteOption := CheckBox5.Checked;
  Archiver.Compress.Option := ComboBox3.ItemIndex;
  Archiver.Compress.Huffman.StopOption := CheckBox7.Checked;
  Archiver.Compress.SlideDic.DicSize := UpDown1.Position * 1024;
  Edit1.Text := IntToStr(Archiver.Compress.SlideDic.DicSize div 1024);
  Archiver.Compress.SlideDic.StopOption := UpDown2.Position;
  Edit2.Text := IntToStr(Archiver.Compress.SlideDic.StopOption);
  Archiver.Compress.SlideDic.LateRating := UpDown3.Position;
  Edit3.Text := IntToStr(Archiver.Compress.SlideDic.LateRating);
  Archiver.Compress.SlideDic.MatchSize := UpDown4.Position;
  Edit4.Text := IntToStr(Archiver.Compress.SlideDic.MatchSize);
  Archiver.Compress.SlideDic.Hash := UpDown5.Position;
  Edit5.Text := IntToStr(Archiver.Compress.SlideDic.Hash);
end;

procedure TFrameForm.SaveParameter;
begin
  Parameter1['WindowState'] := Integer(WindowState);
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
    Parameter1['Top'] := Top; // Integer ^̃f[^𓾂B
    Parameter1['ClientWidth'] := ClientWidth; // Integer ^̃f[^𓾂B
    Parameter1['ClientHeight'] := ClientHeight; // Integer ^̃f[^𓾂B
    Parameter1['Panel1.Height'] := Panel1.Height; // Integer ^̃f[^𓾂B
    Parameter1['Panel3.Width'] := Panel3.Width; // Integer ^̃f[^𓾂B
  end;
  Parameter1['ComboBox1.ItemIndex'] := ComboBox1.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.VStrings['ResFixedDir'] := ResFixedDir; // String ^̃f[^𓾂B
  Parameter1['ComboBox2.ItemIndex'] := ComboBox2.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.VStrings['ArcFixedDir'] := ArcFixedDir; // String ^̃f[^𓾂B
  Parameter1['ComboBox3.ItemIndex'] := ComboBox3.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.VBools['CheckBox1.Checked'] := CheckBox1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox2.Checked'] := CheckBox2.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox3.Checked'] := CheckBox3.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox4.Checked'] := CheckBox4.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox5.Checked'] := CheckBox5.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox6.Checked'] := CheckBox6.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['CheckBox7.Checked'] := CheckBox7.Checked; // Boolean ^̃f[^𓾂B
  Parameter1['UpDown1.Position'] := UpDown1.Position; // Integer ^̃f[^𓾂B
  Parameter1['UpDown2.Position'] := UpDown2.Position; // Integer ^̃f[^𓾂B
  Parameter1['UpDown3.Position'] := UpDown3.Position; // Integer ^̃f[^𓾂B
  Parameter1['UpDown4.Position'] := UpDown4.Position; // Integer ^̃f[^𓾂B
  Parameter1['UpDown5.Position'] := UpDown5.Position; // Integer ^̃f[^𓾂B
  Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['N6.Checked'] := N6.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['D1.Checked'] := D1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.VBools['Memo1.WordWrap'] := Memo1.WordWrap; // Boolean ^̃f[^𓾂B
  Parameter1.VStrings['Memo1.Font.Name'] := Memo1.Font.Name; // String ^̃f[^𓾂B
  Parameter1['Memo1.Font.Size'] := Memo1.Font.Size; // Integer ^̃f[^𓾂B
  Parameter1.VFontStyles['Memo1.Font.Style'] := Memo1.Font.Style; // TFontStyle ^̃f[^𓾂B
  Parameter1['Memo1.Font.Color'] := Memo1.Font.Color; // Integer ^̃f[^𓾂B

  Parameter1.SaveToFile;
end;

procedure TFrameForm.DoExecute;
var
  i: Integer;
  dc, fc: Integer;
  A: String;
  Dir: String;
  DirFile: TDirFile;
begin
  Button1.Enabled := False;
  Button2.Enabled := False;
  Memo1.Clear;

  if Mode = -1 then
    Exit;

  if Mode = ResMode then
    Arrow := ' <= '
  else
    Arrow := ' => ';

  if (Mode = NoneMode) and (Archiver.BaseDir <> '') and (ShowOption = 1) then // 񏑌Ƀ[h
  begin
    Memo1.Lines.Add('===================================================================');
    dc := DirCount;
    fc := AllCount - dc;
    if dc <> 0 then
    begin
      A := IntToStr(dc) + ' ̃fBNg';
      if fc <> 0 then
        A := A + ' ' + IntToStr(fc) + ' ̔񏑌Ƀt@C';
    end
    else
      A := IntToStr(fc) + ' ̔񏑌Ƀt@C';
    A := A + 'Lb`܂B' + #13#10;
    A := A + Archiver.BaseDir + '  (݃fBNg)';
    Memo1.Lines.Add(A);
    Memo1.Lines.Add('===================================================================');
    GetRecs;
    for i := 0 to Recs.Count - 1 do
    begin
      A := Rec2Str(Recs[i]);
      Memo1.Lines.Add(A);
    end;
    Memo1.Lines.Add('===================================================================');
    if (dc <> 0) and (fc = 0) then
      Memo1.Lines.Add('fBNĝ݊܂܂Ă܂B' + #13#10)
    else
    begin
      if N6.Checked then
        Memo1.Lines.Add('t@C  TCY    ^CX^v ̏ŏ\Ă܂B' + #13#10)
      else
        Memo1.Lines.Add('t@C  TCY ̏ŏ\Ă܂B' + #13#10);
    end;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    Recs.Clear;
    Button2.Enabled := True;
    Exit;
  end;

  dc := 0;
  fc := 0;
  if Mode = ArcMode then // ɍ쐬[h
  begin
    if OldCombo2 = 0 then
      Archiver.ArcDir := '' // fXNgbv
    else if OldCombo2 = 1 then
      Archiver.ArcDir := Archiver.BaseDir // t@CƓꏊ
    else if OldCombo2 = 2 then
    begin
      Dir := SelectFolder(Handle, 'ɍ쐬tH_IĉB', '', -1, -1);
      Archiver.ArcDir := Dir; // 쐬̂тɎw肷ꏊ
    end
    else if OldCombo2 = 3 then
      Archiver.ArcDir := ArcFixedDir; // ̑̏ꏊ
    Archiver.ArcFileName := ''; // fBtHgl
    Archiver.Compress.SlideDic.DicSize := UpDown1.Position * 1024;
    Archiver.Compress.SlideDic.StopOption := UpDown2.Position;
    Archiver.Compress.SlideDic.LateRating := UpDown3.Position;
    Archiver.Compress.SlideDic.MatchSize := UpDown4.Position;
    Archiver.Archive;
    DirFile := DispData; dc := DirFile.dc; fc := DirFile.fc;
    if CheckBox6.Checked then
    begin
      Dir := Archiver.ArcDir;
      ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW); // 'explore'
    end;
  end
  else if Mode = ResMode then // ɕ[h
  begin
    if OldCombo1 = 0 then
      Archiver.ResDir := '' // fXNgbv
    else if OldCombo1 = 1 then
        Archiver.ResDir := Archiver.BaseDir // ɂƓꏊ
    else if OldCombo1 = 2 then
    begin
      Dir := SelectFolder(Handle, 'ɕtH_IĉB', '', -1, -1);
      Archiver.ResDir := Dir; // ̂тɎw肷ꏊ
    end
    else if OldCombo1 = 3 then
      Archiver.ResDir := ResFixedDir; // ̑̏ꏊ
    for i := 0 to Archiver.ArcTarget.Count  - 1 do
    begin
      Archiver.ResTarget := Archiver.ArcTarget[i];
      if CheckBox1.Checked then
        Archiver.PackDir := ''; // fBtHgl
      Archiver.Restore;
      DirFile := DispData; dc := dc + DirFile.dc; fc := fc + DirFile.fc;
      if CheckBox3.Checked then
      begin
        Dir := Archiver.ResDir;
        if CheCkBox1.Checked then
        begin
          if Dir[Length(Dir)] <> '\' then
            Dir := Dir + '\';
          Dir := Dir + Archiver.PackDir;
        end;
        ShellExecute(Handle, PChar('open'), PChar(Dir), Nil, Nil, SW_SHOW); // 'explore'
      end;
    end;
  end
  else if Mode = ViewMode then // ɉ{[h
  begin
    for i := 0 to Archiver.ArcTarget.Count  - 1 do
    begin
      Archiver.ResTarget := Archiver.ArcTarget[i];
      DirFile := DispData; dc := dc + DirFile.dc; fc := fc + DirFile.fc;
    end;
    Button1.Enabled := True;
  end;

  if Memo1.Text <> '' then
  begin
    Memo1.Lines.Add('===================================================================');
    if (dc <> 0) and (fc = 0) then
      Memo1.Lines.Add('fBNĝ݊܂܂Ă܂B' + #13#10)
    else
    begin
      if N6.Checked then
        Memo1.Lines.Add('t@C  ̃TCY' + Arrow + 'kTCY (k)    ^CX^v ̏ŏ\Ă܂B' + #13#10)
      else
        Memo1.Lines.Add('t@C  ̃TCY' + Arrow + 'kTCY (k) ̏ŏ\Ă܂B' + #13#10);
    end;
    if Mode = ArcMode then
      Memo1.Lines.Add('HashTable Size = ' + IntToStr(Archiver.Compress.SlideDic.HashTableCount));
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
  end;

{
  if (Button1.Enabled = False) and (Button2.Enabled = False) then
    Archiver.Clear; // ߖׂ̈
}
end;

function TFrameForm.DispData: TDirFile;
var
  i: Integer;
  fs, cs: Integer;
  A: String;
  Dir: String;
begin
  Result.dc := 0;
  Result.fc := 0;
  if (Archiver.Count = 0) or (ShowOption = -1) then // \t@CȂB
    Exit;

  Memo1.Lines.Add('===================================================================');
  if Mode = ArcMode then // ɍ쐬[h
    A := Archiver.ArcFileName
  else
    A := ExtractFileName(Archiver.ResTarget);

  fs := Archiver.OrgSize;
  cs := Archiver.ArcSize;
  A := A + '  ' + IntToStr(fs) + Arrow + IntToStr(cs) +
       ' (' + Percent(cs, fs) + '%)';

  if Mode = ArcMode then // ɍ쐬[h
  begin
    A := A + ' 쐬܂B (ɍ쐬 ' + Archiver.STime + ')' + #13#10;
    A := A + Archiver.BaseDir + '  (݃fBNg)' + #13#10;
    A := A + Archiver.ArcDir + '  (쐬fBNg)';
  end
  else if Mode = ResMode then // ɕ[h
  begin
    A := A + ' 𕜌܂B (ɕ ' + Archiver.STime + ')' + #13#10;
    A := A + ExtractFileDir(Archiver.Restarget) + '  (݃fBNg)' + #13#10;
    Dir := Archiver.ResDir;
    if (Dir[Length(Dir)] <> '\') and (Archiver.PackDir <> '') then
      Dir := Dir + '\';
    Dir := Dir + Archiver.PackDir;
    A := A + Dir + '  (fBNg)';
  end
  else // ɉ{[h
  begin
    A := A + ' ̓ełB (ɉ{)' + #13#10;
    A := A + ExtractFileDir(Archiver.ResTarget) + '  (݃fBNg)';
  end;
  Memo1.Lines.Add(A);

  Memo1.Lines.Add('===================================================================');
  for i := 0 to Archiver.Count - 1 do
  begin
    A := FileHeader2Str(Archiver.FileHeader[i]);
    if Archiver.FileHeader[i].Attribute and faDirectory = 0 then
      Result.fc := Result.fc + 1
    else
      Result.dc := Result.dc + 1;
    Memo1.Lines.Add(A);
  end;
end;

{ X  Y ̉ % ɑ邩_ȉ 1 ܂ŕ\킷Ԃ֐łB}

function TFrameForm.Percent(X, Y: Int64): String;
begin
  Result := '';
  if Y = 0 then
  begin
    if X = 0 then
      Result := '100.0'
    else
      Result := '';
    Exit;
  end;
  X := X * 10000 div Y;
  if X mod 10 >= 5 then
    X := X + 10;
  Y := X div 100; // 2 ̒l
  X := (X mod 100) div 10; // 1 ̒l
  Result := IntToStr(Y) + '.' + IntToStr(X);
end;

{ t@CɃt@Cł邩ǂԂ֐łB}

function TFrameForm.ArchiveFile(FileName: String): Boolean;
begin
  Archiver.ResTarget := FileName;
  if Archiver.ResTarget <> '' then // Ƀt@CłB
    Result := True
  else
    Result := False;
end;

{ Archiver.ArcTarget ̃Xg̒̏Ƀt@C̐Ԃ֐łB}

function TFrameForm.ArcCount: Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to Archiver.ArcTarget.Count - 1 do
  begin
    if ArchiveFile(Archiver.ArcTarget[i]) then // Ƀt@CłB
      Inc(Result);
  end;
end;

{ Archiver.ArcTarget ̃Xg̒̃fBNg̐Ԃ֐łB}

function TFrameForm.DirCount: Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to Archiver.ArcTarget.Count - 1 do
  begin
    if DirectoryExists(Archiver.ArcTarget[i]) then //fBNgłB
      Inc(Result);
  end;
end;

{ Archiver.ArcTarget ̃Xg̒̑St@C̐Ԃ֐łB}

function TFrameForm.AllCount: Integer;
begin
  Result := Archiver.ArcTarget.Count;
end;

{ Archiver.ArcTarget ̃Xg̃t@C Recs Ɏ擾 }
{ ̃t@CԂ֐łB}

function TFrameForm.GetRecs: Integer;
var
  i, j: Integer;
  R: TSearchRec;
begin
  Recs.Clear;
  for i := 0 to Archiver.ArcTarget.Count - 1 do
  begin
    j := FindFirst(Archiver.ArcTarget[i], faAnyFile, R);
    try
      while j = 0 do
      begin
        if (R.Name[1] <> '.') and (R.Attr and faVolumeID = 0) then
          Recs.Add(R);
        j := FindNext(R);
      end;
    finally
      FindClose(R);
    end;
  end;
  Recs.SortRec;
  Result := Recs.Count;
end;

{ t@C Rec 𕶎ɕϊ֐łB}

function TFrameForm.Rec2Str(Rec: TSearchRec): String;
var
  a: Integer;
  d: TDateTime;
  S: String;
begin
  Result := Rec.Name + '  ';
  if Rec.Attr and faDirectory = 0 then
    Result := Result + IntToStr(Rec.Size)
  else
    Result := Result + '<DIR>';

  if N6.Checked  = False then
    Exit;

  a := Rec.Attr;
  S := '';
  if (a and faArchive) > 0 then
    S := S + '  A  ';
  if (a and faReadOnly) > 0 then
    S := S + '  R  ';
  if (a and faHidden) > 0 then
    S := S + '  H  ';
  if (a and faSysFile) > 0 then
    S := S + '  S  ';
  if (a and faDirectory) > 0 then
    S := S + '  D  ';
  if (a and faVolumeID) > 0 then
    S := S + '  V  ';
  if S = '' then
    S := '     ';

  Result := Result + S;

  if FileTimeToDateTime(Rec.FindData.ftLastWriteTime, d) then
    S := FormatDateTime('yyyy/mm/dd hh:nn:ss', d)
  else
    S := ' ';
  Result := Result + S;
end;

{ TFileHeader ̏ 𕶎ɕϊ֐łB}

function TFrameForm.FileHeader2Str(FH: TFileHeader): String;
var
  a: Integer;
  d: TDateTime;
  S: String;
begin
  Result := FH.FileName + '  ';
  if FH.Attribute and faDirectory = 0 then
    Result := Result + IntToStr(FH.FileSize) + Arrow + IntToStr(FH.CompressSize) +
              ' (' + Percent(FH.CompressSize, FH.FileSize) + '%)'
  else
    Result := Result + '<DIR>';

  if N6.Checked  = False then
    Exit;

  a := FH.Attribute;
  S := '';
  if (a and faArchive) > 0 then
    S := S + '  A  ';
  if (a and faReadOnly) > 0 then
    S := S + '  R  ';
  if (a and faHidden) > 0 then
    S := S + '  H  ';
  if (a and faSysFile) > 0 then
    S := S + '  S  ';
  if (a and faDirectory) > 0 then
    S := S + '  D  ';
  if (a and faVolumeID) > 0 then
    S := S + '  V  ';
  if S = '' then
    S := '     ';

  Result := Result + S;

  d := FileDateToDateTime(FH.LastWriteTime);
  S := FormatDateTime('yyyy/mm/dd hh:nn:ss', d);
  Result := Result + S;
end;

{ Path Ɋ܂܂t@CSč폜֐łB}
{ ߂ĺAۂɍ폜֐łB}

function TFrameForm.DeleteFiles(Path: String): Integer;
var
  i: Integer;
  R: TSearchRec;
  Dir: String;
begin
  Result := 0;
  Path := ExpandFileName(Path); // ΃pXɕϊ
  Dir := ExtractFilePath(Path); // fBNg
  i := FindFirst(Path, faAnyFile, R);
  try
    while i = 0 do
    begin
      if (R.Attr and faDirectory = 0) and (DeleteFile(Dir + R.Name)) then
        Inc(Result);
      i := FindNext(R);
    end;
  finally
    FindClose(R);
  end;
end;

procedure TFrameForm.AcceptFiles(var Msg: TMessage);
var
  i, Count: Integer;
  X, Y: Integer;
  AC: Integer;
  S: String;
  Buf: array[0..255] of Char;
begin
  { hbvꂽt@C̐擾B}
  Count := DragQueryFile(Msg.WParam, $FFFFFFFF, Buf, 255);
  Archiver.Clear;
  for i := 0 to Count - 1 do
  begin
    { hbvꂽt@CtpXŎ擾B}
    DragQueryFile(Msg.WParam, i, Buf, 255);
    if not ShortNameToLongName(Buf, S) then // 8.3 `̒Zt@C𒷂t@CɂB
      S := String(Buf);
    Archiver.ArcTarget.Add(S)
  end;
  DragFinish(Msg.WParam);

  { hbvƂ̃}EẌʒu𓾂B}
  X := Mouse.CursorPos.X - Left - (Width - ClientWidth);
  Y := Mouse.CursorPos.Y - Top - (Height - ClientHeight);
  S := 'Compressor Version 1.1';

  Mode := NoneMode;
  AC := ArcCount;
  if AllCount = 0 then
    Mode := -1
  else if Y > Panel1.Height then
  begin
    if AC > 0 then
      Mode := ViewMode;
  end
  else if X > Panel3.Width then
  begin
    Mode := ArcMode;
    Caption := S + ' EEE ɂ쐬Ă܂B';
  end
  else
  begin
    if AC > 0 then
    begin
      Mode := ResMode;
      Caption := S + ' EEE ɂ𕜌Ă܂B';
    end;
  end;

  DoExecute;

  Caption := S;
end;

{ dNh~ׂ̎葱łB}

procedure TFrameForm.WMCopyData(var Msg: TWMCopyData);
var
  S : String;
begin
  if (not X1.Checked) and // dNȂꍇ
     (Msg.CopyDataStruct.dwData = 8086) then // lʎq
  begin
    S := PChar(Msg.CopyDataStruct.lpData);
    if S = 'CPS03' then // ʎq
      Application.Terminate;
  end;
end;

procedure TFrameForm.FormShow(Sender: TObject);
begin
  TempDir := ExtractFilePath(Application.ExeName) + 'HuffmanData';
  if not DirectoryExists(TempDir) then
    CreateDir(TempDir);
  { tH[ւ̃hbOhbvB}
  DragAcceptFiles(Handle, True);
  Tag := 1;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  SaveParameter;
  if D1.Checked then
    DeleteFiles(TempDir + '\*.*');
end;

procedure TFrameForm.FormCreate(Sender: TObject);
var
  i: Integer;
  AC: Integer;
  S: String;
  FileName: TFileName;
begin
  Archiver := TArchiver.Create;
  Recs := TSearchRecs.Create;

  ShowOption := 0; // tH[\邩ǂ܂ĂȂl
  Mode := -1; // [h܂ĂȂl

  for i := 1 to ParamCount do
  begin
    if ParamStr(i)[1] = '/' then // NIvVXCb`
    begin
      case UpCase(ParamStr(i)[2]) of
        'N': Mode := NoneMode;
        'A': Mode := ArcMode;
        'R': Mode := ResMode;
        'V': Mode := ViewMode;
        'H': ShowOption := -1; // ǂ̗lȏꍇłtH[\ȂB
        'S': ShowOption := 1;  // ǂ̗lȏꍇłtH[\B
      end;
    end
    else
    begin
      if not ShortNameToLongName(ParamStr(i), S) then // 8.3 `̒Zt@C𒷂t@CɂB
        S := ParamStr(i);
      Archiver.ArcTarget.Add(S);
    end;
  end;

  AC := ArcCount;

  if ShowOption = 0 then // ̏ꍇtH[\邩ǂŌ߂B
  begin
    if AllCount = 0 then // R}hsɃt@C1nĂȂꍇ
      ShowOption := 1 // tH[\B
    else
      ShowOption := -1; // tH[\ȂB
  end;

  if ShowOption = 1 then // tH[\ꍇ
  begin
    Memo1.Clear;
    Application.ShowMainForm := True;

    if AllCount = 0 then
      Mode := -1
    else if Mode = -1 then // ܂A[h܂ĂȂꍇ
      Mode := ViewMode;

    if (Mode in [ResMode, ViewMode]) and (AC = 0) then
      Mode := NoneMode;

    InitParameter;
    S := 'Compressor Version 1.1';
    if Mode = ArcMode then
      Caption := S + ' EEE ɂ쐬Ă܂B'
    else if Mode = ResMode then
      Caption := S + ' EEE ɂ𕜌Ă܂B';
    DoExecute;
    Caption := S;
    if Memo1.Text = '' then
    begin
      FileName := ExtractFilePath(Application.ExeName) + 'ReadmeC.txt';
      Memo1.Lines.LoadFromFile(FileName);
    end;
  end
  else // tH[\Ȃꍇ
  begin
    if AllCount = 0 then
      Mode := -1
    else
    begin
      if AC = AllCount then // R}hs̃t@CSďɂ̏ꍇ
        Mode := ResMode
      else
        Mode := ArcMode;
    end;

    InitParameter;
    DoExecute;
    Application.Terminate;
  end;
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  Recs.Free;
  Archiver.Free;
end;

procedure TFrameForm.CheckBox4Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.CompressOption := CheckBox4.Checked;
  Parameter1.VBools['CheckBox4.Checked'] := CheckBox4.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox2Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.ResWriteOption := CheckBox2.Checked;
  Parameter1.VBools['CheckBox2.Checked'] := CheckBox2.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox5Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.ArcWriteOption := CheckBox5.Checked;
  Parameter1.VBools['CheckBox5.Checked'] := CheckBox5.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox1Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.PackOption := CheckBox1.Checked;
  Parameter1.VBools['CheckBox1.Checked'] := CheckBox1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox7Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.Compress.Huffman.StopOption := CheckBox7.Checked;
  Parameter1.VBools['CheckBox7.Checked'] := CheckBox7.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.ComboBox1Change(Sender: TObject);
var
  S: String;
begin
  if ComboBox1.ItemIndex = 3 then
  begin
    case OldCombo1 of
      0: Memo1.Text := '݂̏ɕ́AfXNgbvłB';
      1: Memo1.Text := '݂̏ɕ́AɂƓꏊłB';
      2: Memo1.Text := '݂̏ɕ́ÂтɎw肷ꏊłB';
      3: Memo1.Text := '݂̏ɕ́ȂŁA' + #13#10
                       + ResFixedDir + #13#10 + 'łB';
    end;
    S := SelectFolder(Handle, 'ɕtH_IĉB', '', -1, -1);
    if S <> '' then
      ResFixedDir := S
    else
      ComboBox1.ItemIndex := OldCombo1; // O̒lɂǂB
  end;

  OldCombo1 := ComboBox1.ItemIndex; // ݂̒lۑĂB
  if OldCombo1 <> 3 then
    ResFixedDir := '';

  case OldCombo1 of
    0: Memo1.Text := '݂̏ɕ́AfXNgbvłB';
    1: Memo1.Text := '݂̏ɕ́AɂƓꏊłB';
    2: Memo1.Text := '݂̏ɕ́ÂтɎw肷ꏊłB';
    3: Memo1.Text := '݂̏ɕ́ȂŁA' + #13#10
                     + ResFixedDir + #13#10 + 'łB';
  end;

  Parameter1['ComboBox1.ItemIndex'] := ComboBox1.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.VStrings['ResFixedDir'] := ResFixedDir; // String ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.ComboBox2Change(Sender: TObject);
var
  S: String;
begin
  if ComboBox2.ItemIndex = 3 then
  begin
    case OldCombo2 of
      0: Memo1.Text := '݂̏ɍ쐬́AfXNgbvłB';
      1: Memo1.Text := '݂̏ɍ쐬́At@CƓꏊłB';
      2: Memo1.Text := '݂̏ɍ쐬́A쐬̂тɎw肷ꏊłB';
      3: Memo1.Text := '݂̏ɍ쐬́ȂŁA' + #13#10
                       + ArcFixedDir + #13#10 + 'łB';
    end;
    S := SelectFolder(Handle, 'ɍ쐬tH_IĉB', '', -1, -1);
    if S <> '' then
      ArcFixedDir := S
    else
      ComboBox2.ItemIndex := OldCombo2; // O̒lɂǂB
  end;

  OldCombo2 := ComboBox2.ItemIndex; // ݂̒lۑĂB
  if OldCombo2 <> 3 then
    ArcFixedDir := '';

  case OldCombo2 of
    0: Memo1.Text := '݂̏ɍ쐬́AfXNgbvłB';
    1: Memo1.Text := '݂̏ɍ쐬́At@CƓꏊłB';
    2: Memo1.Text := '݂̏ɍ쐬́A쐬̂тɎw肷ꏊłB';
    3: Memo1.Text := '݂̏ɍ쐬́ȂŁA' + #13#10
                     + ArcFixedDir + #13#10 + 'łB';
  end;

  Parameter1['ComboBox2.ItemIndex'] := ComboBox2.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.VStrings['ArcFixedDir'] := ArcFixedDir; // String ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.ComboBox1Enter(Sender: TObject);
begin
  case OldCombo1 of
    0: Memo1.Text := '݂̏ɕ́AfXNgbvłB';
    1: Memo1.Text := '݂̏ɕ́AɂƓꏊłB';
    2: Memo1.Text := '݂̏ɕ́ÂтɎw肷ꏊłB';
    3: Memo1.Text := '݂̏ɕ́ȂŁA' + #13#10
                     + ResFixedDir + #13#10 + 'łB';
  end;
end;

procedure TFrameForm.ComboBox2Enter(Sender: TObject);
begin
  case OldCombo2 of
    0: Memo1.Text := '݂̏ɍ쐬́AfXNgbvłB';
    1: Memo1.Text := '݂̏ɍ쐬́At@CƓꏊłB';
    2: Memo1.Text := '݂̏ɍ쐬́A쐬̂тɎw肷ꏊłB';
    3: Memo1.Text := '݂̏ɍ쐬́ȂŁA' + #13#10
                     + ArcFixedDir + #13#10 + 'łB';
  end;
end;

procedure TFrameForm.PopupMenu1Popup(Sender: TObject);
begin
  if Memo1.Text = '' then
    A2.Enabled := False
  else
    A2.Enabled := True;

  if Memo1.WordWrap then
    N1.Checked := True
  else
    N1.Checked := False;

  if AssociateExists('.cps') then
    A1.Checked := True
  else
    A1.Checked := False;
end;

procedure TFrameForm.H1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'ReadmeC.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.F1Click(Sender: TObject);
begin
  FontDialog1.Font := Memo1.Font;
  if FontDialog1.Execute then
    Memo1.Font := FontDialog1.Font;
end;

procedure TFrameForm.N1Click(Sender: TObject);
begin
  Memo1.WordWrap := not Memo1.WordWrap;
  if Memo1.WordWrap then
    Memo1.ScrollBars := ssNone
  else
    Memo1.ScrollBars := ssBoth;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
  S: String;
begin
  S := 'Compressor Version 1.1';
  if (Memo1.Lines[0])[1] = '=' then
  begin
    Mode := ResMode;
    Caption := S + ' EEE ɂ𕜌Ă܂B';
  end;
  DoExecute;
  Caption := S;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
var
  S: String;
begin
  S := 'Compressor Version 1.1';
  if (Memo1.Lines[0])[1] = '=' then
  begin
    Mode := ArcMode;
    Caption := S + ' EEE ɂ쐬Ă܂B';
  end;
  DoExecute;
  Caption := S;
end;

procedure TFrameForm.A1Click(Sender: TObject);
var
  rs: Boolean;
  R: TExtensionRec;
begin
  Memo1.Clear;
  if A1.Checked then
  begin
    try
      rs := AssociateDelete('.cps'); // gq̊֘At̉
    except
      rs := False;
    end;
    if rs then
      Memo1.Lines.Add('gq ".cps" ̊֘At܂B')
    else
      Memo1.Lines.Add('gq ".cps" ̊֘Ato܂łB');
  end
  else
  begin
    R.Extension := '.cps'; // gq
    R.ExtensionKey := 'CPSFile'; // gq̊i[惌WXgL[
    R.ExtensionName := 'CPSɃt@C'; // gqt@C̈ʌď
    R.DefaultIcon := ''; // gq̃ACȐݐ
    R.Command := '"' + Application.ExeName + '"' + ' /S /V ' + '"%1"'; // t@CJɎsR}h
    try
      rs := AssociateMake(R); // gq̊֘At̍쐬
    except
      rs := False;
    end;
    if rs then
    begin
      Memo1.Lines.Add('gq ".cps" ̊֘At܂BGNXv[Ŋgq');
      Memo1.Lines.Add('".cps" ̃t@CJƁACompressor Nďɂ̓e');
      Memo1.Lines.Add('View [hŕ\܂BView [hŕ\oȂꍇ');
      Memo1.Lines.Add('None [hŃt@Ĉݕ\܂B');
    end
    else
      Memo1.Lines.Add('gq ".cps" ̊֘Ato܂łB');
  end;
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'Compressor Version 1.1 Copyright (C) 2020 ` 2021 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.N4Click(Sender: TObject);
begin
  Memo1.Clear;
  InitAll;
  SaveParameter;
  Memo1.Lines.Add('Compressor Ԃɂ܂B');
end;

procedure TFrameForm.X1Click(Sender: TObject);
begin
  X1.Checked := not X1.Checked;

  Memo1.Clear;
  if X1.Checked then
    Memo1.Lines.Add('Compressor ̓dN\Ƃ܂B' + #13#10 +
                    'ȌA Compressor ̋N\ƂȂ܂B')
  else
    Memo1.Lines.Add('Compressor ̓dNs\Ƃ܂B' + #13#10 +
                    'ȌACompressor N邲ƂɒOɋN' + #13#10 +
                    'Compressor I܂B');

  Parameter1.VBools['X1.Checked'] := X1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox3Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1.VBools['CheckBox3.Checked'] := CheckBox3.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.CheckBox6Click(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1.VBools['CheckBox6.Checked'] := CheckBox6.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit1Change(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1['UpDown1.Position'] := UpDown1.Position; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit2Change(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1['UpDown2.Position'] := UpDown2.Position; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit3Change(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1['UpDown3.Position'] := UpDown3.Position; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Edit4Change(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Parameter1['UpDown4.Position'] := UpDown4.Position; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.N6Click(Sender: TObject);
begin
  N6.Checked := not N6.Checked;

  if Button1.Enabled or Button2.Enabled then
    DoExecute
  else
  begin
    Memo1.Clear;
    if N6.Checked then
      Memo1.Lines.Add('t@ĆAڍׂȏ\܂B')
    else
      Memo1.Lines.Add('t@ĆAt@CƃTCŶݕ\܂B');
  end;

  Parameter1.VBools['N6.Checked'] := N6.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.A2Click(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TFrameForm.Edit5Change(Sender: TObject);
begin
  if Tag = 0 then Exit;
  Archiver.Compress.SlideDic.Hash := UpDown5.Position;
  Parameter1['UpDown5.Position'] := UpDown5.Position; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.ComboBox3Change(Sender: TObject);
begin
  case ComboBox3.ItemIndex of
    0: Memo1.Text := '݂̈ḱAkłB';
    1: Memo1.Text := '݂̈ḱAHuffman ݂̂g܂B';
    2: Memo1.Text := '݂̈ḱALZ77 ݂̂g܂B';
    3: Memo1.Text := '݂̈ḱALZ77  Huffman g܂B';
  end;

  Archiver.Compress.Option := ComboBox3.ItemIndex;
  Parameter1['ComboBox3.ItemIndex'] := ComboBox3.ItemIndex; // Integer ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.ComboBox3Enter(Sender: TObject);
begin
  case ComboBox3.ItemIndex of
    0: Memo1.Text := '݂̈ḱAkłB';
    1: Memo1.Text := '݂̈ḱAHuffman ݂̂g܂B';
    2: Memo1.Text := '݂̈ḱALZ77 ݂̂g܂B';
    3: Memo1.Text := '݂̈ḱALZ77  Huffman g܂B';
  end;
end;

procedure TFrameForm.RealData1Click(Sender: TObject);
var
  Len, N: Integer;
  S: String;
  ExeName: String;
  FileName: String;
begin
  S := '';
  N := Archiver.Count - 1;
  if N >= 0 then
  begin
    while (N >= 0) and (Archiver.FileHeader[N].Attribute and faDirectory > 0) do
      Dec(N);
    if N <> -1 then
    begin
      FileName := ChangeFileExt(ExtractFileName(Archiver.FileHeader[N].FileName), '') + 'M.gen'; // 'M.fre'
      FileName := ExtractFilePath(Application.ExeName) + 'HuffmanData\' + FileName;
      S := Archiver.Compress.SlideDic.SHuffmanLen(False);
    end;
  end;

  if S = '' then
  begin
    if (N <> -1) and (Archiver.FileHeader[N].FileSize = 0) then
      Memo1.Text := 'TCY 0 ̃t@C̃nt}z͕\o܂B'
    else
      Memo1.Text := 'ṽnt}z LZ77 ɂ鈳ksȂ' +
                    #13#10 + 'Ȃƕ\o܂B';
  end
  else
  begin
    Memo1.Text := S;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';

    if FileExists(ExeName) then
    begin
      Len := Archiver.Compress.SlideDic.MatchSize - 3 + 1;
      {
      N := HuffmanFrequency(Archiver.Compress.SlideDic.FrequencyM,
                            Len,
                            FileName, //  FileName ̃t@C 쐬B
                            False);
      }
      N := GeneralFrequency(Archiver.Compress.SlideDic.FrequencyM,
                            Len,
                            FileName); //  FileName ̃t@C 쐬B
      if (N > 0) and (FileExists(FileName)) then
        ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                     PChar('/G1 /I1 /D2 ' + '"' + FileName + '"'), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.FullSpecData1Click(Sender: TObject);
var
  Len, N: Integer;
  S: String;
  ExeName: String;
  FileName: String;
begin
  S := '';
  N := Archiver.Count - 1;
  if N >= 0 then
  begin
    while (N >= 0) and (Archiver.FileHeader[N].Attribute and faDirectory > 0) do
      Dec(N);
    if N <> -1 then
    begin
      FileName := ChangeFileExt(ExtractFileName(Archiver.FileHeader[N].FileName), '') + 'M.gen'; // 'M.fre'
      FileName := ExtractFilePath(Application.ExeName) + 'HuffmanData\' + FileName;
      S := Archiver.Compress.SlideDic.SHuffmanLen(True);
    end;
  end;

  if S = '' then
  begin
    if (N <> -1) and (Archiver.FileHeader[N].FileSize = 0) then
      Memo1.Text := 'TCY 0 ̃t@C̃nt}z͕\o܂B'
    else
      Memo1.Text := 'ṽnt}z LZ77 ɂ鈳ksȂ' +
                    #13#10 + 'Ȃƕ\o܂B';
  end
  else
  begin
    Memo1.Text := S;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';

    if FileExists(ExeName) then
    begin
      Len := Archiver.Compress.SlideDic.MatchSize - 3 + 1;
      {
      N := HuffmanFrequency(Archiver.Compress.SlideDic.FrequencyM,
                            Len,
                            FileName, //  FileName ̃t@C 쐬B
                            True);
      }
      N := GeneralFrequency(Archiver.Compress.SlideDic.FrequencyM,
                            Len,
                            FileName); //  FileName ̃t@C 쐬B
      if (N > 0) and (FileExists(FileName)) then
        ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                     PChar('/G1 /I1 /D2 ' + '"' + FileName + '"'), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.RealData2Click(Sender: TObject);
var
  X, Len, N: Integer;
  S: String;
  ExeName: String;
  FileName: String;
begin
  S := '';
  N := Archiver.Count - 1;
  if N >= 0 then
  begin
    while (N >= 0) and (Archiver.FileHeader[N].Attribute and faDirectory > 0) do
      Dec(N);
    if N <> -1 then
    begin
      FileName := ChangeFileExt(ExtractFileName(Archiver.FileHeader[N].FileName), '') + 'D.gen'; // 'D.fre'
      FileName := ExtractFilePath(Application.ExeName) + 'HuffmanData\' + FileName;
      S := Archiver.Compress.SlideDic.SHuffmanDist(False);
    end;
  end;

  if S = '' then
  begin
    if (N <> -1) and (Archiver.FileHeader[N].FileSize = 0) then
      Memo1.Text := 'TCY 0 ̃t@C̃nt}z͕\o܂B'
    else
      Memo1.Text := 'vʒũrbg̃nt}z LZ77 ɂ鈳ksȂ' +
                    #13#10 + 'Ȃƕ\o܂B';
  end
  else
  begin
    Memo1.Text := S;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';

    if FileExists(ExeName) then
    begin
      X := Archiver.Compress.SlideDic.DicSize - Archiver.Compress.SlideDic.MatchSize;
      Len := BitCount(X); // ݎvʒũrbg̗vf
      {
      N := HuffmanFrequency(Archiver.Compress.SlideDic.FrequencyD,
                            Len,
                            FileName, //  FileName ̃t@C쐬B
                            False);
      }
      N := GeneralFrequency(Archiver.Compress.SlideDic.FrequencyD,
                            Len,
                            FileName); //  FileName ̃t@C쐬B
      if (N > 0) and (FileExists(FileName)) then
        ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                     PChar('/G1 /I1 /D2 ' + '"' + FileName + '"'), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.RealData3Click(Sender: TObject);
var
  X, Len, N: Integer;
  S: String;
  ExeName: String;
  FileName: String;
begin
  S := '';
  N := Archiver.Count - 1;
  if N >= 0 then
  begin
    while (N >= 0) and (Archiver.FileHeader[N].Attribute and faDirectory > 0) do
      Dec(N);
    if N <> -1 then
    begin
      FileName := ChangeFileExt(ExtractFileName(Archiver.FileHeader[N].FileName), '') + 'D.gen'; // 'D.fre'
      FileName := ExtractFilePath(Application.ExeName) + 'HuffmanData\' + FileName;
      S := Archiver.Compress.SlideDic.SHuffmanDist(True);
    end;
  end;

  if S = '' then
  begin
    if (N <> -1) and (Archiver.FileHeader[N].FileSize = 0) then
      Memo1.Text := 'TCY 0 ̃t@C̃nt}z͕\o܂B'
    else
      Memo1.Text := 'vʒũrbg̃nt}z LZ77 ɂ鈳ksȂ' +
                    #13#10 + 'Ȃƕ\o܂B';
  end
  else
  begin
    Memo1.Text := S;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    ExeName := ExtractFilePath(Application.ExeName) + 'HuffGen.exe';

    if FileExists(ExeName) then
    begin
      X := Archiver.Compress.SlideDic.DicSize - Archiver.Compress.SlideDic.MatchSize;
      Len := BitCount(X); // ݎvʒũrbg̗vf
      {
      N := HuffmanFrequency(Archiver.Compress.SlideDic.FrequencyD,
                            Len,
                            FileName, //  FileName ̃t@C쐬B
                            True);
      }
      N := GeneralFrequency(Archiver.Compress.SlideDic.FrequencyD,
                            Len,
                            FileName); //  FileName ̃t@C쐬B
      if (N > 0) and (FileExists(FileName)) then
        ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                     PChar('/G1 /I1 /D2 ' + '"' + FileName + '"'), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.D1Click(Sender: TObject);
begin
  D1.Checked := not D1.Checked;

  Memo1.Clear;
  if D1.Checked then
    Memo1.Lines.Add('Compressor ̏IɈꎞt@C폜܂B')
  else
    Memo1.Lines.Add('Compressor ̏IɈꎞt@C폜܂B');

  Parameter1.VBools['D1.Checked'] := D1.Checked; // Boolean ^̃f[^𓾂B
  Parameter1.SaveToFile;
end;

procedure TFrameForm.FullSpec1Click(Sender: TObject);
var
  X, N, LenM, LenD: Integer;
  S: String;
  FileName: String;
begin
  LenM := MatchSizeMax - 3 + 1;
  X := DicSizeMax - MatchSizeMax;
  LenD := BitCount(X); // ݎvʒũrbg̗vf

  S := '';
  N := Archiver.Count - 1;
  if N >= 0 then
  begin
    while (N >= 0) and (Archiver.FileHeader[N].Attribute and faDirectory > 0) do
      Dec(N);
    if N <> -1 then
    begin
      FileName := ChangeFileExt(ExtractFileName(Archiver.FileHeader[N].FileName), '') + '.arr';
      FileName := ExtractFilePath(Application.ExeName) + 'HuffmanData\' + FileName;
      S := HuffmanArray(Archiver.Compress.SlideDic.FrequencyM, LenM, True, 'v');
    end;
  end;

  if S = '' then
    Memo1.Text := 'nt}z̔z\ LZ77 ɂ鈳ksȂ' +
                  #13#10 + 'Ȃƕ\o܂B'
  else
  begin
    S := S + #13#10 + HuffmanArray(Archiver.Compress.SlideDic.FrequencyD, LenD, True, 'vʒũrbg');
    Memo1.Text := S;
    Memo1.SelStart := 0;
    Memo1.Perform(EM_SCROLLCARET,0, 0);
    Memo1.Lines.SaveToFile(FileName);
  end;
end;

end.
